"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var reselect_1 = require("reselect");
var stapp_1 = require("stapp");
var constants_1 = require("./constants");
exports.loaderStart = stapp_1.createEvent(constants_1.LOADERS + ": Loading start");
exports.loaderEnd = stapp_1.createEvent(constants_1.LOADERS + ": Loading end");
var loadersReducer = stapp_1.createReducer({})
    .on(exports.loaderStart, function (loadersState, name) {
    var _a;
    return loadersState[name]
        ? loadersState
        : __assign({}, loadersState, (_a = {}, _a[name] = true, _a));
})
    .on(exports.loaderEnd, function (loadersState, name) {
    var _a;
    return !loadersState[name]
        ? loadersState
        : __assign({}, loadersState, (_a = {}, _a[name] = false, _a));
});
exports.isLoadingSelector = function () {
    return reselect_1.createSelector(function (state) {
        return state.loaders || {};
    }, function (loadersState) {
        return Object.keys(loadersState).filter(function (name) { return loadersState[name]; }).length > 0;
    });
};
exports.loaders = function () { return ({
    name: constants_1.LOADERS,
    state: {
        loaders: loadersReducer
    }
}); };
//# sourceMappingURL=loaders.js.map